/*
 * $Id: tzprefs.c,v 1.1.6.1 2020/11/10 21:16:43 piru Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"

#define DEBUG 0
#include <aros/debug.h>

/*********************************************************************************************/

static void TZHandler(void)
{
	struct Process *me = (struct Process *) FindTask(NULL);
	#if 0
	APTR oldwinptr = me->pr_WindowPtr;
	#endif
	struct MsgPort notifyport;
	struct NotifyRequest nr;

	D(bug("%s:\n",__func__));

	//me->pr_WindowPtr = (APTR) -1;

	notifyport.mp_Node.ln_Type = NT_MSGPORT;
	notifyport.mp_SigBit  = SIGBREAKB_CTRL_F;
	notifyport.mp_SigTask = &me->pr_Task;
	notifyport.mp_Flags   = PA_SIGNAL;
	NEWLIST(&notifyport.mp_MsgList);

	memset(&nr, 0, sizeof(nr));
	nr.nr_Name  = "ENV:TZ";
	nr.nr_Flags = NRF_SEND_MESSAGE | NRF_NOTIFY_INITIAL;
	nr.nr_stuff.nr_Msg.nr_Port = &notifyport;
	if (!StartNotify(&nr))
	{
		D(bug("%s: StartNotify failed\n",__func__));
		return;
	}

	for (;;)
	{
		struct NotifyMessage *nm;
		BOOL changed = FALSE;
		UBYTE buf[256];

		WaitPort(&notifyport);

		while ((nm = (struct NotifyMessage *) GetMsg(&notifyport)))
		{
			ReplyMsg(&nm->nm_ExecMessage);
			changed = TRUE;
		}
		if (!changed)
		{
			/* Spurious signal? - do nothing */
			continue;
		}

		if (GetVar("TZ", buf, sizeof(buf), LV_VAR | GVF_GLOBAL_ONLY) <= 0)
		{
			/* File was deleted? - do nothing */
			continue;
		}

		/* set new global timezone */
		TZSetSysTimeZone(buf);
	}

#if 0 /* never reached */
	EndNotify(&nr);

	me->pr_WindowPtr = oldwinptr;
#endif
}

/*********************************************************************************************/

#define HANDLER_NAME	"TimeZoneHandler"

void SetupTZHandler(void)
{

	D(bug("%s: <%s>\n",__func__,filename));

	if (LocaleBase->lib_Version >= 53)
	{
		struct Process	*MyProcess;

		D(bug("%s: Launch TimeZoneHandler\n",__func__));

		MyProcess = CreateNewProcTags(NP_Entry,(ULONG) &TZHandler,
		                              NP_Name,(ULONG) HANDLER_NAME,
		                              NP_Priority, 1,
		                              NP_CodeType,MACHINE_PPC,
		                              NP_ConsoleTask, 0,
		                              NP_CurrentDir, 0,
		                              NP_CopyVars, FALSE,
		                              NP_WindowPtr, -1,
		                              NP_HomeDir, 0,
		                              TAG_END);
	}
}
